%Serial Correlation Tests

function [coef_tau, se_tau, t_tau]=TransitionMatrix1c

clc
clear

display('TransitionMatrix1c**********************') 
load Data_GMMmain; 
load Data_ReadyPTM;
load Data_tau;

% W{i}: (1)Y (2)LAG Y (3)hsize 
% (4)d02 (5)d03 (6)d04 (7)d05 (8)d06 (9)d07 
% (10)l2_is_head (11)l3_is_head  
% (12)l_is_head

% tau_it-3 added
T=T-3;
Kex=Kex+1-3;

% calculate the size of Z
LagBegin=3; % first internal IV - t-3 
sgiv=4+5+6; % internal IV t-3 and t-4 :15
sei=2*(T-LagBegin); % t-2 and t-3 lags *3 years external IVs: 6
sex=(Kex-2)*(T-LagBegin); % # of exogenous variable is reduced (dummy correction) 
sZ=sgiv+sex+sei; %size of Z:  3K+3+15+6+3=30 with K=1, and 1 constant each year
sW=Kex+1; %size of W: 6

% initiate matrices
obs=0;
ANINV0=zeros(sZ,sZ);
WZ=zeros(sW,sZ);
ZW=zeros(sZ,sW);
Zy=zeros(sZ,1);

s1=0;

% to construct Z instrument matrix
 for i=1:ng
  
   % first differencing (but keep time dummies as levels)
   for t=1:3
   W_star0{i}(t,1:sW+1)=[W{i}(t+6,1:3)-W{i}(t+5,1:3) W{i}(t+6, 7:9) d_tau{i}(t+3,6)]; % consumption and hhsize first differencing
   end
      
   % to control sample size for l_is_head
   % to control sample size for ln_l3_at_cons (preserving t-3 consumption)
   for t=1:3
   W_star0{i}(t,sW+2:sW+3)=[W{i}(t+6,12) W{i}(t+3,1)];    
   end

   % GMM-Style instrumental variable matrix Z
   % exogenous variables (differenced) and external IVs (not differenced)
   % without dummy variables (but a constant term included)
   Z{i}(:,:)=zeros(3,sZ);   % initiate matrix
   Z{i}(1,1:1+4+1+2+1)   = [1 W{i}(1,1) W{i}(2,1) W{i}(3,1) W{i}(4,1)                     W_star0{i}(1, 3) W{i}(7, 10:11) d_tau{i}(4,6)];
   Z{i}(2,10:10+5+1+2+1) = [1 W{i}(1,1) W{i}(2,1) W{i}(3,1) W{i}(4,1) W{i}(5,1)           W_star0{i}(2, 3) W{i}(8, 10:11) d_tau{i}(5,6)];
   Z{i}(3,20:20+6+1+2+1) = [1 W{i}(1,1) W{i}(2,1) W{i}(3,1) W{i}(4,1) W{i}(5,1) W{i}(6,1) W_star0{i}(3, 3) W{i}(9, 10:11) d_tau{i}(6,6)];
      

   %to keep observations with NaN for consumption at t-4 and earlier
   if  isnan(W{i}(1,1))==1
       Z{i}(1,2)=0;
       Z{i}(2,11)=0;
       Z{i}(3,21)=0;
   end
   if isnan(W{i}(2,1))==1
       Z{i}(1,3)=0;
       Z{i}(2,12)=0;
       Z{i}(3,22)=0;
   end
   if isnan(W{i}(3,1))==1
       Z{i}(1,4)=0;
       Z{i}(2,13)=0;
       Z{i}(3,23)=0; 
   end
   if isnan(W{i}(4,1))==1
       Z{i}(2,14)=0;
       Z{i}(3,24)=0; 
   end
   if isnan(W{i}(5,1))==1
       Z{i}(3,25)=0; 
   end
   
   DXY0{i}=W_star0{i}(:,1:9);
   DXY0{i}(1,10)=2005;
   DXY0{i}(2,10)=2006;
   DXY0{i}(3,10)=2007;
   DXY0{i}(1,11)=i;
   DXY0{i}(2,11)=i;
   DXY0{i}(3,11)=i;
   
   I1{i}=W_star0{i};
   I2{i}=Z{i};
   
   % sample size control, delete NaN 
   k2=0; 
   for t=1:3
        if sum(isnan(W_star0{i}(t-k2,:)))>0 || sum(isnan(Z{i}(t-k2,:)))>0  
        W_star0{i}(t-k2,:)=[];
        Z{i}(t-k2,:)=[];
        SS{i}(t-k2,:)=[];
        k2=k2+1;  
       end
   end
 
 end
 
 W_star0(cellfun(@isempty, W_star0)) = [];
 Z(cellfun(@isempty, Z)) = [];
 SS(cellfun(@isempty, SS)) = [];
 
 ng_m=size(W_star0,2)
 
 
for i=1:ng_m
   % dependent and independent variables
   W_star{i}=W_star0{i}(:,2:7);
   y_star{i}=W_star0{i}(:,1);
    
   % calculating # of observations (this is not # of groups)
   s=size(W_star0{i},1);
   obs=obs+s;
      
   % Weight Matrix for one step estimator
   H0{i}=eye(3,3);
      
   % for unbalanced panel      
   for j=1:3-s
   H0{i}(:,3-j+1)=[];
   H0{i}(3-j+1,:)=[];
   end   
   
   AN00{i}=Z{i}'*H0{i}*Z{i}; 
   ANINV0=(ANINV0+AN00{i});
   WZ0{i}=W_star{i}'*Z{i};
   WZ=(WZ+WZ0{i});
   ZW0{i}=Z{i}'*W_star{i};
   ZW=(ZW+ZW0{i});
   Zy0{i}=Z{i}'*y_star{i};
   Zy=(Zy+Zy0{i});
 end
  
 ANINV0=ANINV0/ng_m;
 ev1=eig(ANINV0);
 if min(ev1)<=0
     disp('Warning: One-step Covariance matrix of moment conditions is singular')
 end
 AN0=inv(ANINV0); 
  
 % one-step estimator
 delta1=(inv(WZ*AN0*ZW))*(WZ*AN0*Zy);
 ev11=eig(WZ*AN0*ZW);
 if min(ev11)<=0
     disp('Warning: Matrix is singular')
 end
 
 ANINV=zeros(sZ,sZ);
 
 for i=1:ng_m
  % residuals from the first step GMM   
  r{i}=y_star{i}-W_star{i}*delta1;
  % weight matrix for two step estimator
  H1{i}= (r{i})*(r{i})';
  AN1{i}=Z{i}'*H1{i}*Z{i}; 
  ANINV=(ANINV+AN1{i});
 end
  
 ANINV=ANINV/ng_m; 
 ev2=eig(ANINV);
 if min(ev2)<=0
     disp('Warning: Two-step Covariance matrix of moment conditions is singular')
 end
 AN=inv(ANINV);
   
 % two-step estimator
 delta=(inv(WZ*AN*ZW))*(WZ*AN*Zy);
 ev22=eig(WZ*AN*ZW);
 if min(ev22)<=0
     disp('Warning: Matrix is singular')
 end 
 
 % two-step estimator standard errors (before transformation)
 VarDelta=ng_m*diag((inv(WZ*AN*ZW)));
 sqroot=(1/2)*ones(size(VarDelta,1),1);
 StdDelta=VarDelta.^sqroot;
 
 % Hansen J statistics
 rZ=zeros(1,sZ);
 Zr=zeros(sZ,1);
 
 for i=1:ng_m
    rZ0{i}=r{i}'*Z{i};
    rZ=rZ+rZ0{i};
    Zr0{i}=Z{i}'*r{i};
    Zr=Zr+Zr0{i};
 end
  
 HJ=(1/ng_m)*rZ*AN*Zr;
 NI=size(AN,2);
 p_chiHJ=1-chi2cdf(HJ,NI-8);
   
% original parameterization for time dummies
A=blkdiag(eye(2,2),tril(ones(3,3)),ones(1,1));
delta_c=A*delta;
delta=delta_c;
% two-step estimator standard errors (after transformation)
VarDelta_c=A*((inv(WZ*AN*ZW)))*A';
VarDelta=ng_m*diag(VarDelta_c);
sqroot=(1/2)*ones(size(VarDelta,1),1);
StdDelta=VarDelta.^sqroot;

estimates_survey=delta;
t=delta./StdDelta;

[delta StdDelta t];
obs

coef_tau=delta(6,1);
se_tau=StdDelta(6,1);
t_tau=t(6,1);

return