/* this is generating 1999 file*/

cd C:\PTM_code\Preparation
set more off

/* Note: unknown or nonresponse value for satisfaction and income information */
/* Note: coding value of unkwown or nonresponse different over the waves */

/*1999------------------------------------------------------------------------*/
/* I. this part is to generate income satisfaction variables at 1998 */
use basic98_individual.dta, clear

generate is_head=.
replace is_head=c_inc_sati if relate==10 & c_inc_sati!=9
generate is_spouse=.
replace is_spouse=c_inc_sati if relate==20 & c_inc_sati!=9
generate ls_head=.
replace ls_head=c_life_sati if relate==10 & c_life_sati!=9
generate ls_spouse=.
replace ls_spouse=c_life_sati if relate==20 & c_life_sati!=9

collapse (sum)   is_head is_spouse ls_head ls_spouse, by(hhid)

replace is_head=. if is_head>5 | is_head==0
replace is_spouse=. if is_spouse>5 | is_spouse==0
replace ls_head=. if ls_head>5 | ls_head==0
replace ls_spouse=. if ls_spouse>5 | ls_spouse==0

sort hhid
save basic98_isatisfaction.dta, replace

/* II. this part is to generate r_total_income for 1998 --------------------------------------------------------------- */
/* IA. bring 1998 hsize to 1999 file l_hsize  */
use cleaned98_household.dta, clear
generate l_hsize=hsize
keep hhid l_hsize
sort hhid
save cleaned99_lhsize_merge.dta, replace

/* IC. generate l_r_total_income at 1999 for r_total_income  1998----------------------------------------- */
use cleaned99_household.dta, clear

sort hhid
joinby hhid using cleaned99_lhsize_merge.dta, unmatched(master)
drop _merge

/* attrition blank */
replace seoul=. if hwave02==0
replace hage=. if hwave02==0
replace sq_hage=. if hwave02==0
replace hsex=. if hwave02==0
replace nonspouse=. if hwave02==0

/* III. this part to merge 1998 satisfaction to 1999 l_satisfaction ----------------------------------------*/
sort hhid
joinby using basic98_isatisfaction.dta, unm(master)
drop _merge
generate l_is_head=is_head
generate l_is_spouse=is_spouse
generate l_ls_head=ls_head
generate l_ls_spouse=ls_spouse
drop is_head is_spouse ls_head ls_spouse

save cleanup99_total.dta, replace
