/* Korean Consumption Dynamics: KLIPS 1-11 */
/* Transform Raw Data to Yearly Basic Household Information Data */

cd C:\PTM_code\Preparation

/* 1998 */
use klips01h, clear

generate year=1998

generate l_cons0=v01454
generate l_cons1=.
generate l_cons2=.
generate l_cons3=.
generate l_cons4=.
generate l_cons5=.
generate l_cons6=.
generate l_cons7=.
generate l_cons8=.
generate l_cons9=.
generate l_cons10=.
generate l_cons11=.
generate l_cons12=.
generate l_cons13=.
generate l_cons14=.
generate l_cons15=.
generate l_cons16=.
generate l_cons17=.

keep year hhid hwave01 sample98 l_cons* 

save consumption1998_1997.dta, replace

/* 1999 */
use klips02h, clear

generate year=1999

generate l_cons0=v02649
generate l_cons1=v02650
generate l_cons2=v02651
generate l_cons3=v02652
generate l_cons4=v02653
generate l_cons5=v02654
generate l_cons6=v02655
generate l_cons7=v02656
generate l_cons8=v02657
generate l_cons9=v02658
generate l_cons10=v02659
generate l_cons11=.
generate l_cons12=.
generate l_cons13=.
generate l_cons14=.
generate l_cons15=.
generate l_cons16=.
generate l_cons17=v02660

keep year hhid hwave02 sample98 l_cons* 

save consumption1999_1998.dta, replace

clear

/* 2000 */
use klips03h, clear

generate year=2000

generate l_cons0=v03835
generate l_cons1=.
generate l_cons2=.
generate l_cons3=.
generate l_cons4=.
generate l_cons5=.
generate l_cons6=.
generate l_cons7=.
generate l_cons8=.
generate l_cons9=.
generate l_cons10=.
generate l_cons11=.
generate l_cons12=.
generate l_cons13=.
generate l_cons14=.
generate l_cons15=.
generate l_cons16=.
generate l_cons17=.

keep year hhid hwave03 sample98 l_cons* 

save consumption2000_1999.dta, replace

/* 2001 */
*use klips04h, clear
insheet using klips04h_oldversion.txt, clear
* some values of the variables in a new release of klips wave 4 are different from the old version. 
* please contact me if you want to have the old version of klips wave 4.

*generate year=2001

generate l_cons0=v04918
generate l_cons1=v04919
generate l_cons2=v04920
generate l_cons3=v04921
generate l_cons4=v04922
generate l_cons5=v04923
generate l_cons6=v04924
generate l_cons7=v04925
generate l_cons8=v04926
generate l_cons9=v04927
generate l_cons10=v04928
generate l_cons11=v04929
generate l_cons12=.
generate l_cons13=.
generate l_cons14=.
generate l_cons15=.
generate l_cons16=.
generate l_cons17=v04930

keep year hhid hwave04 sample98 l_cons* 

save consumption2001_2000.dta, replace

clear

/* 2002 */
use klips05h, clear

generate year=2002

generate l_cons0=v05776
generate l_cons1=v05777
generate l_cons2=v05778
generate l_cons3=v05779
generate l_cons4=v05780
generate l_cons5=v05781
generate l_cons6=v05782
generate l_cons7=v05783
generate l_cons8=v05784
generate l_cons9=v05785
generate l_cons10=v05786
generate l_cons11=v05787
generate l_cons12=v05788
generate l_cons13=.
generate l_cons14=.
generate l_cons15=.
generate l_cons16=.
generate l_cons17=v05789

keep year hhid hwave05 sample98 l_cons* 

save consumption2002_2001.dta, replace

/* 2003 */
use klips06h, clear

generate year=2003

generate l_cons0=v06691
generate l_cons1=v06692
generate l_cons2=v06693
generate l_cons3=v06694
generate l_cons4=v06695
generate l_cons5=v06696
generate l_cons6=v06697
generate l_cons7=v06698
generate l_cons8=v06699
generate l_cons9=v06700
generate l_cons10=v06701
generate l_cons11=v06702
generate l_cons12=v06703
generate l_cons13=v06704
generate l_cons14=.
generate l_cons15=.
generate l_cons16=.
generate l_cons17=v06705

keep year hhid hwave06 sample98 l_cons* 

save consumption2003_2002.dta, replace

/* 2004 */
use klips07h, clear

generate sample98=SAMPLE98 
generate year=2004 
generate hhid=HHID
generate hwave07=HWAVE07

generate l_cons0=V07747
generate l_cons1=V07748
generate l_cons2=V07749
generate l_cons3=V07750
generate l_cons4=V07751
generate l_cons5=V07752
generate l_cons6=V07753
generate l_cons7=V07754
generate l_cons8=V07755
generate l_cons9=V07756
generate l_cons10=V07757
generate l_cons11=V07758
generate l_cons12=V07759
generate l_cons13=V07760
generate l_cons14=V07761
generate l_cons15=V07762
generate l_cons16=V07763
generate l_cons17=V07764

keep year hhid hwave07 sample98 l_cons* 

save consumption2004_2003.dta, replace


/* 2005 */
use klips08h.dta, clear

generate sample98=SAMPLE98 
generate year=2005 
generate hhid=HHID

generate l_cons0=v08747
generate l_cons1=v08748
generate l_cons2=v08749
generate l_cons3=v08750
generate l_cons4=v08751
generate l_cons5=v08752
generate l_cons6=v08753
generate l_cons7=v08754
generate l_cons8=v08755
generate l_cons9=v08756
generate l_cons10=v08757
generate l_cons11=v08758
generate l_cons12=v08759
generate l_cons13=v08760
generate l_cons14=v08761
generate l_cons15=v08762
generate l_cons16=v08763
generate l_cons17=v08764

keep year hhid hwave08 sample98 l_cons* 

save consumption2005_2004.dta, replace


/* 2006 */
use klips09h.dta, clear
 
generate sample98=SAMPLE98
generate hhid=HHID
generate year=2006 

generate l_cons0=v09747  
generate l_cons1=v09748
generate l_cons2=v09749
generate l_cons3=v09750
generate l_cons4=v09751
generate l_cons5=v09752
generate l_cons6=v09753
generate l_cons7=v09754
generate l_cons8=v09755
generate l_cons9=v09756
generate l_cons10=v09757
generate l_cons11=v09758
generate l_cons12=v09759a
generate l_cons13=v09759b
generate l_cons14=v09759c
generate l_cons15=v09760
generate l_cons16=v09761
generate l_cons17=v09762
generate l_cons18=v09763
generate l_cons19=v09763a
generate l_cons20=v09764

keep year hhid hwave09 sample98 l_cons*

save consumption2006_2005.dta, replace

/* 2007 */
use klips10h.dta, clear
 
generate hhid=hhidwon
generate year=2007 

generate l_cons0=h102301  
generate l_cons1=h102311   
generate l_cons2=h102312
generate l_cons3=h102313
generate l_cons4=h102314
generate l_cons5=h102315
generate l_cons6=h102316
generate l_cons7=h102317
generate l_cons8=h102318
generate l_cons9=h102319
generate l_cons10=h102320
generate l_cons11=h102321
generate l_cons12=h102323
generate l_cons13=h102324
generate l_cons14=h102325
generate l_cons15=h102326
generate l_cons16=h102327
generate l_cons17=h102328
generate l_cons18=h102329
generate l_cons19=h102330
generate l_cons20=h102331


keep year hhid hwave10 sample98 l_cons* 

save consumption2007_2006.dta, replace

/* 2008 */
use klips11h.dta, clear
 
generate hhid=hhidwon
generate year=2008 

generate l_cons0=h112301  
generate l_cons1=h112311 
generate l_cons2=h112312
generate l_cons3=h112313
generate l_cons4=h112314
generate l_cons5=h112315
generate l_cons6=h112316
generate l_cons7=h112317
generate l_cons8=h112318
generate l_cons9=h112319
generate l_cons10=h112320
generate l_cons11=h112321
generate l_cons12=h112323
generate l_cons13=h112324
generate l_cons14=h112325
generate l_cons15=h112326
generate l_cons16=h112327
generate l_cons17=h112328
generate l_cons18=h112329
generate l_cons19=h112330
generate l_cons20=h112331
generate l_cons21=h112332


keep year hhid hwave11 sample98 l_cons* 

save consumption2008_2007.dta, replace
